#ifndef WFPAGE_H
#define WFPAGE_H

#include "wfdisplay_global.h"

#include <QtGui/QMainWindow>
#include <QRadioButton>
#include <QPushButton>
#include <QDockWidget>
#include <QToolBar>
#include <QLabel>
#include <QFile>
#include <QTextStream>
#include <QFileDialog>

#include <wfplot.h>
#include <wfdisplay_params.h>

class WFDISPLAYSHARED_EXPORT WFPage : public QMainWindow
{
    Q_OBJECT
public:
    explicit WFPage(QWidget *parent = 0);

    void createToolBar();
    void buildDockList();
    void unTabify();
    void tabify();
    // STORE
    void chooseLogFile();
    void buildFileNames();
    bool islogfileenable();
    void appendToLogFile(const QString & text);
    void closeEvent(QCloseEvent *event);

    QLabel *logFileName;

    QWidget *titleWidgetV;
    QWidget *titleWidgetE1;
    QWidget *titleWidgetE2;
    QWidget *titleWidgetB1;
    QWidget *titleWidgetB2;
    QWidget *titleWidgetB3;

    QList<QDockWidget*> dockList;

    QDockWidget *dockV;
    QDockWidget *dockE1;
    QDockWidget *dockE2;
    QDockWidget *dockB1;
    QDockWidget *dockB2;
    QDockWidget *dockB3;

    QRadioButton *radio_v;
    QRadioButton *radio_e1;
    QRadioButton *radio_e2;
    QRadioButton *radio_b1;
    QRadioButton *radio_b2;
    QRadioButton *radio_b3;
    QRadioButton *radio_tabify;

    QPushButton *button_selectAll;
    QPushButton *button_storeWfrm;

    QToolBar *myToolBar;

    WFPlot *wfPlot_v;
    WFPlot *wfPlot_e1;
    WFPlot *wfPlot_e2;
    WFPlot *wfPlot_b1;
    WFPlot *wfPlot_b2;
    WFPlot *wfPlot_b3;

    QFile *logFile;
    QFile *logFileV;
    QFile *logFileE1;
    QFile *logFileE2;
    QFile *logFileB1;
    QFile *logFileB2;
    QFile *logFileB3;

    QTextStream *logFileStrm;
    QTextStream *logFileStrmV;
    QTextStream *logFileStrmE1;
    QTextStream *logFileStrmE2;
    QTextStream *logFileStrmB1;
    QTextStream *logFileStrmB2;
    QTextStream *logFileStrmB3;

    bool logFileEn;

    //QGridLayout *mainLayout;

    void displayOnPlot(short *data, unsigned char num);
    
signals:
    void setLogFileName(QString FileName);
    
public slots:
    void actionRadioV(bool state);
    void actionRadioE1(bool state);
    void actionRadioE2(bool state);
    void actionRadioB1(bool state);
    void actionRadioB2(bool state);
    void actionRadioB3(bool state);
    void organizeDocks();
    void selectAll();
    void storeWfrm();
    void logFileEnDisable(bool state);
    
};

#endif // WFPAGE_H
